// Chess 
// Copyright (C) 2005  Steve Driscoll (steviedisco@gmail.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

#ifndef FUNCTIONS_H
#define FUNCTIONS_H

class Functions
{
  public:
    static void ConvertCoords(const int position, Ogre::Real &X, Ogre::Real &Z)
    {
      // i'm shat at maths - i'm sure there's a *much* better way to do this...
      int temp = position;
      Z = -70 + (20 * int(temp / 8));
      while (temp > 7) temp -= 8;
      X = -70 + (20 * temp);  
    }

    static bool GetNearestPosition(const Ogre::Vector3 input, Ogre::Vector3& output, int& position)
    {
      // i'm shat at maths - i'm sure there's a *much* better way to do this...
      output = input;
      position = 0;

      // deal with the z values first
      Ogre::Real temp = output.z;
      int count = 0;
      while (temp > -60) {
        temp -= 20;
        count++;
      }
      position += (count * 8);
      output.z = -80 + (20*count+10);

      // then the x
      temp = output.x;
      count = 0;
      while (temp > -60) {
        temp -= 20;
        count++;
      }
      position += count;
      output.x = -80 + (20*count+10);      
      
      // raise it a bit
      output.y = 1;

      return (output.x >= -80 && output.x <= 80 && output.z >= -80 && output.z <= 80); 
    }
};

#endif
